unsigned long long ts;

void merge(double * const a, double * const tmp,
	   unsigned long long start, unsigned long long end)
{
	unsigned long long mid  = (start + end) / 2;
	unsigned long long i    = start;
	unsigned long long j    = mid + 1;
	unsigned long long h    = start;

	while ( (h <= mid) && (j <= end) )
	{
		if (a[h] <= a[j])
			tmp[i++] = a[h++];
		else
			tmp[i++] = a[j++];
	}

	if (h > mid) {
		for (unsigned long long k = j; k <= end; k++)
			tmp[i++] = a[k];
	}
	else {
		for (unsigned long long k = h; k <= mid; k++)
			tmp[i++] = a[k];
	}

	for (unsigned long long k = start; k <= end; k++) {
		a[k] = tmp[k];
	}
}

void merge_sort_rec(double * const a, double * const tmp,
		    unsigned long long start, unsigned long long end)
{
	unsigned long long mid = (start + end) / 2;
	unsigned long long n1 = (mid - start) + 1;
	unsigned long long n2 = (end - mid);

	if (start < mid) {
		#pragma oss task final(end-start+1 < ts)
		merge_sort_rec(a, tmp, start, mid);
	}

	if (mid+1 < end) {
		// Task not needed as we are going to wait before it anyway
		merge_sort_rec(a, tmp, mid + 1, end);
	}
	#pragma oss taskwait
	merge(a, tmp, start, end);
}


void merge_sort(double *a, unsigned long long n)
{
	double * const tmp =  new double[n];
	merge_sort_rec(a, tmp, 0, n-1);
	delete[] tmp;
}
