#include <iostream>
#include <stdlib.h>
#include <sys/time.h>
#include <cstdlib>
#include <cassert>

extern unsigned long long ts;

void merge_sort(double *a, unsigned long long n);

int main(int argc, char **argv) {

	if (argc != 3) {
		std::cerr << "[USAGE] " << argv[0]
			  	  << " size chunksize" << std::endl;
		return 1;
	}

	const unsigned long long n = atoll(argv[1]);
	ts = atoll(argv[2]);

	double * const a = new double[n];

	for (long i = 0; i < n; ++i) {
		a[i] = ((double) (rand() * 5)) + ((double) (rand() / 3));
	}

	struct timespec start, end;
	clock_gettime(CLOCK_MONOTONIC, &start);

	merge_sort(a, n);

	clock_gettime(CLOCK_MONOTONIC, &end);
	double duration = (end.tv_sec - start.tv_sec) * 1000000 +
		          (end.tv_nsec - start.tv_nsec) / 1000;
	duration /= 1000000;

	double performance = n;
	performance = performance / duration;
	performance /= 1000000000;

	std::cout << "size: " << n << ", bs: " << ts << ", time: "
		  << duration << ", performance: " << performance << std::endl;

	for(unsigned long long i=1; i<n; i++){
		assert(a[i-1] <= a[i]);
	}

	delete[] a;

	return 0;
}

